<?php
/*------------------------------------------------------------------------
# product.php - Product advisor Component
# ------------------------------------------------------------------------
# author    Matthias Drobny, drobny.iT
# copyright Copyright (C) 2014. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   www.drobny.it
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla modelform library
jimport('joomla.application.component.modeladmin');

/**
 * Product Model
 */
class ProductadvisorModelProduct extends JModelAdmin
{
// protected $_data;
	/**
	 * Method override to check if you can edit an existing record.
	 *
	 * @param	array	$data	An array of input data.
	 * @param	string	$key	The name of the key for the primary key.
	 *
	 * @return	boolean
	 * @since	2.5
	 */
	protected function allowEdit($data = array(), $key = 'product_id')
	{
		// Check specific edit permission then general edit permission.
		return JFactory::getUser()->authorise('core.edit', 'com_productadvisor.message.'. ((int) isset($data[$key]) ? $data[$key] : 0)) or parent::allowEdit($data, $key);
	}

	/**
	 * Returns a reference to the a table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	2.5
	 */
	public function getTable($type = 'Products', $prefix = 'ProductadvisorTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	/**
	 * Method to get the record form.
	 *
	 * @param	array	$data		Data for the form.
	 * @param	boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return	mixed	A JForm object on success, false on failure
	 * @since	2.5
	 */
	public function getForm($data = array(), $loadData = true)
	{
// 		return FALSE;
		// Get the form.
		$form = $this->loadForm('com_productadvisor.Product', 'Product', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)){
			return false;
		};
// echo "<pre>";
// echo __LINE__;
// print_r($form);
// die();
// echo "#############";
// echo "</pre>";
		return $form;
	}

	/**
	 * Method to get the script that have to be included on the form
	 *
	 * @return string	script files
	 */
	public function getScript()
	{
		return 'administrator/components/com_productadvisor/models/forms/product.js';
	}

	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return	mixed	The data for the form.
	 * @since	2.5
	 */
	protected function loadFormData() 
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_productadvisor.edit.product.data', array());
		if (empty($data)){
			$data = $this->getItem();
		};
// echo __LINE__;
// print_r($data);
// die();

		$data = (object) $data;
		$data->attributes=$this->getProductAttributes($data->product_id);
		return $data;
	}

	public function getProductAttributes($id=NULL) {
		$model = $this->getInstance('ProductattributesList', 'ProductadvisorModel');
		$model->set('_product_id', $id);
		return $model->getProductattributes();
	}

	public function getByOrderID($id) {
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->select('p.*');
		$query->from('#__productadvisor_products AS p');
		$query->where('p.order_id = "'.$id.'"');
		$db->setQuery($query);
		return $db->loadObject();
	}
	
	public function save($data) {
// 		$data['jform'] = JRequest::getVar( 'jform', '', 'post', 'array');
// 		$tmp = JRequest::getVar( 'jform', '', 'post', 'array', JREQUEST_ALLOWHTML);
// 		$data['jform']['description'] = $tmp['description'];
// 		$data = JRequest::get('foo');
// 		if(!is_null($data)) {
// 			$data = (array) $data;
// 			$data2 = $data;
// 		} else {
			$data = JRequest::getVar('jform', array(), 'post', 'array');
			
			$data2['new_productattribute_catid']	= JRequest::getVar( 'new_productattribute_catid', array(), 'post', 'array');
			$data2['new_productattribute_value']	= JRequest::getVar( 'new_productattribute_value', array(), 'post', 'array' );
			$data2['del_productattribute_id']		= JRequest::getVar( 'del_productattribute_id', array(), 'post', 'array' );
// 		}
		parent::save($data);
// echo __FILE__;
// echo "<pre>";
// echo $this->getState('product' . '.id', 'product_id');
		
// echo "#############";
if(empty($data['product_id'])) {
	$data['product_id'] = $this->getState('product' . '.id', 'product_id');
}
// print_r($data);
// print_r($this);
// var_dump($return);

// echo "#############";
// echo "</pre>";
// die();

		$model = $this->getInstance('Productattributes', 'ProductadvisorModel');
// 		$model->save($data + $data2);
		$model->save($data + $data2);
		JFactory::getApplication()->setUserState('com_productadvisor.edit.product.data', $data);
		return TRUE;
	}
}
?>